libstdc++: std::regex_constants Namespace Reference

libstdc++

std::regex_constants Namespace Reference
Regular Expressions

## 5.1 Regular Expression Syntax Options
enum | syntax_option_type : unsigned int { _S_icase , _S_nosubs , _S_optimize , _S_collate , _S_ECMAScript , _S_basic , _S_extended , _S_awk , _S_grep , _S_egrep , _S_polynomial , _S_multiline }
constexpr syntax_option_type | icase
constexpr syntax_option_type | nosubs
constexpr syntax_option_type | optimize
constexpr syntax_option_type | collate
constexpr syntax_option_type | ECMAScript
constexpr syntax_option_type | basic
constexpr syntax_option_type | extended
constexpr syntax_option_type | awk
constexpr syntax_option_type | grep
constexpr syntax_option_type | egrep
constexpr syntax_option_type | multiline
constexpr syntax_option_type | __multiline
constexpr syntax_option_type | __polynomial
constexpr syntax_option_type | operator& (syntax_option_type __a, syntax_option_type __b) noexcept
constexpr syntax_option_type | operator| (syntax_option_type __a, syntax_option_type __b) noexcept
constexpr syntax_option_type | operator^ (syntax_option_type __a, syntax_option_type __b) noexcept
constexpr syntax_option_type | operator~ (syntax_option_type __a) noexcept
constexpr syntax_option_type & | operator&= (syntax_option_type &__a, syntax_option_type __b) noexcept
constexpr syntax_option_type & | operator|= (syntax_option_type &__a, syntax_option_type __b) noexcept
constexpr syntax_option_type & | operator^= (syntax_option_type &__a, syntax_option_type __b) noexcept

## 5.2 Matching Rules
Matching a regular expression against a sequence of characters [first, last) proceeds according to the rules of the grammar specified for the regular expression object, modified according to the effects listed below for any bitmask elements set.
enum | match_flag_type : unsigned int { _S_default , _S_not_bol , _S_not_eol , _S_not_bow , _S_not_eow , _S_any , _S_not_null , _S_continuous , _S_prev_avail , _S_sed , _S_no_copy , _S_first_only , _S_match_flag_last }
constexpr match_flag_type | match_default
constexpr match_flag_type | match_not_bol
constexpr match_flag_type | match_not_eol
constexpr match_flag_type | match_not_bow
constexpr match_flag_type | match_not_eow
constexpr match_flag_type | match_any
constexpr match_flag_type | match_not_null
constexpr match_flag_type | match_continuous
constexpr match_flag_type | match_prev_avail
constexpr match_flag_type | format_default
constexpr match_flag_type | format_sed
constexpr match_flag_type | format_no_copy
constexpr match_flag_type | format_first_only
constexpr match_flag_type | operator& (match_flag_type __a, match_flag_type __b) noexcept
constexpr match_flag_type | operator| (match_flag_type __a, match_flag_type __b) noexcept
constexpr match_flag_type | operator^ (match_flag_type __a, match_flag_type __b) noexcept
constexpr match_flag_type | operator~ (match_flag_type __a) noexcept
constexpr match_flag_type & | operator&= (match_flag_type &__a, match_flag_type __b) noexcept
constexpr match_flag_type & | operator|= (match_flag_type &__a, match_flag_type __b) noexcept
constexpr match_flag_type & | operator^= (match_flag_type &__a, match_flag_type __b) noexcept

## 5.3 Error Types
enum | error_type { _S_error_collate , _S_error_ctype , _S_error_escape , _S_error_backref , _S_error_brack , _S_error_paren , _S_error_brace , _S_error_badbrace , _S_error_range , _S_error_space , _S_error_badrepeat , _S_error_complexity , _S_error_stack , _S_null , _S_grammar }
constexpr error_type | error_collate (_S_error_collate)
constexpr error_type | error_ctype (_S_error_ctype)
constexpr error_type | error_escape (_S_error_escape)
constexpr error_type | error_backref (_S_error_backref)
constexpr error_type | error_brack (_S_error_brack)
constexpr error_type | error_paren (_S_error_paren)
constexpr error_type | error_brace (_S_error_brace)
constexpr error_type | error_badbrace (_S_error_badbrace)
constexpr error_type | error_range (_S_error_range)
constexpr error_type | error_space (_S_error_space)
constexpr error_type | error_badrepeat (_S_error_badrepeat)
constexpr error_type | error_complexity (_S_error_complexity)
constexpr error_type | error_stack (_S_error_stack)

## Detailed Description

ISO C++ 2011 namespace for options and flags used with std::regex.

## Enumeration Type Documentation

## ◆ error_type

enum std::regex_constants::error_type

The expression contained an invalid collating element name.

Definition at line 49 of file regex_error.h.

## ◆ match_flag_type

enum std::regex_constants::match_flag_type : unsigned int

This is a bitmask type indicating regex matching rules.

The `match_flag_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

Definition at line 253 of file regex_constants.h.

## ◆ syntax_option_type

enum std::regex_constants::syntax_option_type : unsigned int

This is a bitmask type indicating how to interpret the regex.

The `syntax_option_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

A valid value of type syntax_option_type shall have exactly one of the elements `ECMAScript`, `basic`, `extended`, `awk`, `grep`, `egrep` set.

Definition at line 69 of file regex_constants.h.

## Function Documentation

## ◆ error_backref()

error_type std::regex_constants::error_backref | ( | _S_error_backref |  | ) |
| inlineconstexpr

The expression contained an invalid back reference.

## ◆ error_badbrace()

error_type std::regex_constants::error_badbrace | ( | _S_error_badbrace |  | ) |
| inlineconstexpr

The expression contained an invalid range in a {} expression.

## ◆ error_badrepeat()

error_type std::regex_constants::error_badrepeat | ( | _S_error_badrepeat |  | ) |
| inlineconstexpr

One of *?+{ was not preceded by a valid regular expression.

## ◆ error_brace()

error_type std::regex_constants::error_brace | ( | _S_error_brace |  | ) |
| inlineconstexpr

The expression contained mismatched { and }

## ◆ error_brack()

error_type std::regex_constants::error_brack | ( | _S_error_brack |  | ) |
| inlineconstexpr

The expression contained mismatched [ and ].

## ◆ error_collate()

error_type std::regex_constants::error_collate | ( | _S_error_collate |  | ) |
| inlineconstexpr

The expression contained an invalid collating element name.

## ◆ error_complexity()

error_type std::regex_constants::error_complexity | ( | _S_error_complexity |  | ) |
| inlineconstexpr

The complexity of an attempted match against a regular expression exceeded a pre-set level.

## ◆ error_ctype()

error_type std::regex_constants::error_ctype | ( | _S_error_ctype |  | ) |
| inlineconstexpr

The expression contained an invalid character class name.

## ◆ error_escape()

error_type std::regex_constants::error_escape | ( | _S_error_escape |  | ) |
| inlineconstexpr

The expression contained an invalid escaped character, or a trailing escape.

## ◆ error_paren()

error_type std::regex_constants::error_paren | ( | _S_error_paren |  | ) |
| inlineconstexpr

The expression contained mismatched ( and ).

## ◆ error_range()

error_type std::regex_constants::error_range | ( | _S_error_range |  | ) |
| inlineconstexpr

The expression contained an invalid character range, such as [b-a] in most encodings.

## ◆ error_space()

error_type std::regex_constants::error_space | ( | _S_error_space |  | ) |
| inlineconstexpr

There was insufficient memory to convert the expression into a finite state machine.

## ◆ error_stack()

error_type std::regex_constants::error_stack | ( | _S_error_stack |  | ) |
| inlineconstexpr

There was insufficient memory to determine whether the regular expression could match the specified character sequence.

## ◆ operator&() [1/2]

match_flag_type std::regex_constants::operator& | ( | match_flag_type | __a,
|  | match_flag_type | __b )
| constexprnoexcept

This is a bitmask type indicating regex matching rules.

The `match_flag_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

Definition at line 372 of file regex_constants.h.

## ◆ operator&() [2/2]

syntax_option_type std::regex_constants::operator& | ( | syntax_option_type | __a,
|  | syntax_option_type | __b )
| constexprnoexcept

This is a bitmask type indicating how to interpret the regex.

The `syntax_option_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

A valid value of type syntax_option_type shall have exactly one of the elements `ECMAScript`, `basic`, `extended`, `awk`, `grep`, `egrep` set.

Definition at line 191 of file regex_constants.h.

## ◆ operator&=() [1/2]

match_flag_type & std::regex_constants::operator&= | ( | match_flag_type & | __a,
|  | match_flag_type | __b )
| inlineconstexprnoexcept

This is a bitmask type indicating regex matching rules.

The `match_flag_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

Definition at line 401 of file regex_constants.h.

## ◆ operator&=() [2/2]

syntax_option_type & std::regex_constants::operator&= | ( | syntax_option_type & | __a,
|  | syntax_option_type | __b )
| inlineconstexprnoexcept

This is a bitmask type indicating how to interpret the regex.

The `syntax_option_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

A valid value of type syntax_option_type shall have exactly one of the elements `ECMAScript`, `basic`, `extended`, `awk`, `grep`, `egrep` set.

Definition at line 220 of file regex_constants.h.

## ◆ operator^() [1/2]

match_flag_type std::regex_constants::operator^ | ( | match_flag_type | __a,
|  | match_flag_type | __b )
| constexprnoexcept

This is a bitmask type indicating regex matching rules.

The `match_flag_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

Definition at line 388 of file regex_constants.h.

## ◆ operator^() [2/2]

syntax_option_type std::regex_constants::operator^ | ( | syntax_option_type | __a,
|  | syntax_option_type | __b )
| constexprnoexcept

This is a bitmask type indicating how to interpret the regex.

The `syntax_option_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

A valid value of type syntax_option_type shall have exactly one of the elements `ECMAScript`, `basic`, `extended`, `awk`, `grep`, `egrep` set.

Definition at line 207 of file regex_constants.h.

## ◆ operator^=() [1/2]

match_flag_type & std::regex_constants::operator^= | ( | match_flag_type & | __a,
|  | match_flag_type | __b )
| inlineconstexprnoexcept

This is a bitmask type indicating regex matching rules.

The `match_flag_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

Definition at line 411 of file regex_constants.h.

## ◆ operator^=() [2/2]

syntax_option_type & std::regex_constants::operator^= | ( | syntax_option_type & | __a,
|  | syntax_option_type | __b )
| inlineconstexprnoexcept

This is a bitmask type indicating how to interpret the regex.

The `syntax_option_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

A valid value of type syntax_option_type shall have exactly one of the elements `ECMAScript`, `basic`, `extended`, `awk`, `grep`, `egrep` set.

Definition at line 230 of file regex_constants.h.

## ◆ operator|() [1/2]

match_flag_type std::regex_constants::operator| | ( | match_flag_type | __a,
|  | match_flag_type | __b )
| constexprnoexcept

This is a bitmask type indicating regex matching rules.

The `match_flag_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

Definition at line 380 of file regex_constants.h.

## ◆ operator|() [2/2]

syntax_option_type std::regex_constants::operator| | ( | syntax_option_type | __a,
|  | syntax_option_type | __b )
| constexprnoexcept

This is a bitmask type indicating how to interpret the regex.

The `syntax_option_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

A valid value of type syntax_option_type shall have exactly one of the elements `ECMAScript`, `basic`, `extended`, `awk`, `grep`, `egrep` set.

Definition at line 199 of file regex_constants.h.

## ◆ operator|=() [1/2]

match_flag_type & std::regex_constants::operator|= | ( | match_flag_type & | __a,
|  | match_flag_type | __b )
| inlineconstexprnoexcept

This is a bitmask type indicating regex matching rules.

The `match_flag_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

Definition at line 406 of file regex_constants.h.

## ◆ operator|=() [2/2]

syntax_option_type & std::regex_constants::operator|= | ( | syntax_option_type & | __a,
|  | syntax_option_type | __b )
| inlineconstexprnoexcept

This is a bitmask type indicating how to interpret the regex.

The `syntax_option_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

A valid value of type syntax_option_type shall have exactly one of the elements `ECMAScript`, `basic`, `extended`, `awk`, `grep`, `egrep` set.

Definition at line 225 of file regex_constants.h.

## ◆ operator~() [1/2]

match_flag_type std::regex_constants::operator~ | ( | match_flag_type | __a | ) |
| constexprnoexcept

This is a bitmask type indicating regex matching rules.

The `match_flag_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

Definition at line 396 of file regex_constants.h.

## ◆ operator~() [2/2]

syntax_option_type std::regex_constants::operator~ | ( | syntax_option_type | __a | ) |
| constexprnoexcept

This is a bitmask type indicating how to interpret the regex.

The `syntax_option_type` is implementation defined but it is valid to perform bitwise operations on these values and expect the right thing to happen.

A valid value of type syntax_option_type shall have exactly one of the elements `ECMAScript`, `basic`, `extended`, `awk`, `grep`, `egrep` set.

Definition at line 215 of file regex_constants.h.

## Variable Documentation

## ◆ __multiline

syntax_option_type std::regex_constants::__multiline
| inlineconstexpr

Extension: Equivalent to regex_constants::multiline for C++11 and C++14.

Definition at line 179 of file regex_constants.h.

## ◆ __polynomial

syntax_option_type std::regex_constants::__polynomial
| inlineconstexpr

Extension: Ensure both space complexity of compiled regex and time complexity execution are not exponential. If specified in a regex with back-references, the exception regex_constants::error_complexity will be thrown.

Definition at line 187 of file regex_constants.h.

## ◆ awk

syntax_option_type std::regex_constants::awk
| inlineconstexpr

Specifies that the grammar recognized by the regular expression engine is that used by POSIX utility awk in IEEE Std 1003.1-2001. This option is identical to syntax_option_type extended, except that C-style escape sequences are supported. These sequences are: \\, \a, \b, \f, \n, \r, \t , \v, \&apos,, &apos,, and \ddd (where ddd is one, two, or three octal digits).

Definition at line 147 of file regex_constants.h.

## ◆ basic

syntax_option_type std::regex_constants::basic
| inlineconstexpr

Specifies that the grammar recognized by the regular expression engine is that used by POSIX basic regular expressions in IEEE Std 1003.1-2001, Portable Operating System Interface (POSIX), Base Definitions and Headers, Section 9, Regular Expressions [IEEE, Information Technology – Portable Operating System Interface (POSIX), IEEE Standard 1003.1-2001].

Definition at line 129 of file regex_constants.h.

## ◆ collate

syntax_option_type std::regex_constants::collate
| inlineconstexpr

Specifies that character ranges of the form [a-b] should be locale sensitive.

Definition at line 110 of file regex_constants.h.

## ◆ ECMAScript

syntax_option_type std::regex_constants::ECMAScript
| inlineconstexpr

Specifies that the grammar recognized by the regular expression engine is that used by ECMAScript in ECMA-262 [Ecma International, ECMAScript Language Specification, Standard Ecma-262, third edition, 1999], as modified in section [28.13]. This grammar is similar to that defined in the PERL scripting language but extended with elements found in the POSIX regular expression grammar.

Definition at line 120 of file regex_constants.h.

## ◆ egrep

syntax_option_type std::regex_constants::egrep
| inlineconstexpr

Specifies that the grammar recognized by the regular expression engine is that used by POSIX utility grep when given the -E option in IEEE Std 1003.1-2001. This option is identical to syntax_option_type extended, except that newlines are treated as whitespace.

Definition at line 163 of file regex_constants.h.

## ◆ extended

syntax_option_type std::regex_constants::extended
| inlineconstexpr

Specifies that the grammar recognized by the regular expression engine is that used by POSIX extended regular expressions in IEEE Std 1003.1-2001, Portable Operating System Interface (POSIX), Base Definitions and Headers, Section 9, Regular Expressions.

Definition at line 137 of file regex_constants.h.

## ◆ format_default

match_flag_type std::regex_constants::format_default
| inlineconstexpr

When a regular expression match is to be replaced by a new string, the new string is constructed using the rules used by the ECMAScript replace function in ECMA- 262 [Ecma International, ECMAScript Language Specification, Standard Ecma-262, third edition, 1999], part 15.5.4.11 String.prototype.replace. In addition, during search and replace operations all non-overlapping occurrences of the regular expression are located and replaced, and sections of the input that did not match the expression are copied unchanged to the output string.

Format strings (from ECMA-262 [15.5.4.11]):

- $$ The dollar-sign itself ($)
- $& The matched substring.
- $` The portion of the string that precedes the matched substring. This would be match_results::prefix().
- $' The portion of the string that follows the matched substring. This would be match_results::suffix().
- $n The nth capture, where n is a positive integer less than 100. If n <= match_results::size() and the nth capture is undefined, use the empty string instead. If n > match_results::size(), the result is implementation-defined.

Definition at line 347 of file regex_constants.h.

Referenced by std::match_results< _BidirectionalIterator, polymorphic_allocator< sub_match< _BidirectionalIterator > > >< const char * >::format(), std::match_results< _BidirectionalIterator, polymorphic_allocator< sub_match< _BidirectionalIterator > > >< const char * >::format(), std::match_results< _BidirectionalIterator, polymorphic_allocator< sub_match< _BidirectionalIterator > > >< const char * >::format(), and std::match_results< _BidirectionalIterator, polymorphic_allocator< sub_match< _BidirectionalIterator > > >< const char * >::format().

## ◆ format_first_only

match_flag_type std::regex_constants::format_first_only
| inlineconstexpr

When specified during a search and replace operation, only the first occurrence of the regular expression shall be replaced.

Definition at line 368 of file regex_constants.h.

## ◆ format_no_copy

match_flag_type std::regex_constants::format_no_copy
| inlineconstexpr

During a search and replace operation, sections of the character container sequence being searched that do not match the regular expression shall not be copied to the output string.

Definition at line 362 of file regex_constants.h.

## ◆ format_sed

match_flag_type std::regex_constants::format_sed
| inlineconstexpr

When a regular expression match is to be replaced by a new string, the new string is constructed using the rules used by the POSIX sed utility in IEEE Std 1003.1- 2001 [IEEE, Information Technology – Portable Operating System Interface (POSIX), IEEE Standard 1003.1-2001].

Definition at line 355 of file regex_constants.h.

## ◆ grep

syntax_option_type std::regex_constants::grep
| inlineconstexpr

Specifies that the grammar recognized by the regular expression engine is that used by POSIX utility grep in IEEE Std 1003.1-2001. This option is identical to syntax_option_type basic, except that newlines are treated as whitespace.

Definition at line 155 of file regex_constants.h.

## ◆ icase

syntax_option_type std::regex_constants::icase
| inlineconstexpr

Specifies that the matching of regular expressions against a character sequence shall be performed without regard to case.

Definition at line 89 of file regex_constants.h.

## ◆ match_any

match_flag_type std::regex_constants::match_any
| inlineconstexpr

If more than one match is possible then any match is an acceptable result.

Definition at line 305 of file regex_constants.h.

## ◆ match_continuous

match_flag_type std::regex_constants::match_continuous
| inlineconstexpr

The expression only matches a sub-sequence that begins at first .

Definition at line 315 of file regex_constants.h.

Referenced by std::regex_iterator< _Bi_iter, _Ch_type, _Rx_traits >::operator++().

## ◆ match_default

match_flag_type std::regex_constants::match_default
| inlineconstexpr

The default matching rules.

Definition at line 273 of file regex_constants.h.

Referenced by std::regex_iterator< const char * >::regex_iterator(), std::regex_token_iterator< const char * >::regex_token_iterator(), std::regex_token_iterator< const char * >::regex_token_iterator(), std::regex_token_iterator< const char * >::regex_token_iterator(), std::regex_token_iterator< const char * >::regex_token_iterator(), std::regex_match(), std::regex_match(), std::regex_match(), std::regex_match(), std::regex_match(), std::regex_match(), std::regex_match(), std::regex_replace(), std::regex_replace(), std::regex_replace(), std::regex_replace(), std::regex_replace(), std::regex_replace(), std::regex_search(), std::regex_search(), std::regex_search(), std::regex_search(), std::regex_search(), std::regex_search(), and std::regex_search().

## ◆ match_not_bol

match_flag_type std::regex_constants::match_not_bol
| inlineconstexpr

The first character in the sequence [first, last) is treated as though it is not at the beginning of a line, so the character (^) in the regular expression shall not match [first, first).

Definition at line 280 of file regex_constants.h.

## ◆ match_not_bow

match_flag_type std::regex_constants::match_not_bow
| inlineconstexpr

The expression \b is not matched against the sub-sequence [first,first).

Definition at line 293 of file regex_constants.h.

## ◆ match_not_eol

match_flag_type std::regex_constants::match_not_eol
| inlineconstexpr

The last character in the sequence [first, last) is treated as though it is not at the end of a line, so the character ($) in the regular expression shall not match [last, last).

Definition at line 287 of file regex_constants.h.

## ◆ match_not_eow

match_flag_type std::regex_constants::match_not_eow
| inlineconstexpr

The expression \b should not be matched against the sub-sequence [last,last).

Definition at line 299 of file regex_constants.h.

## ◆ match_not_null

match_flag_type std::regex_constants::match_not_null
| inlineconstexpr

The expression does not match an empty sequence.

Definition at line 310 of file regex_constants.h.

Referenced by std::regex_iterator< _Bi_iter, _Ch_type, _Rx_traits >::operator++().

## ◆ match_prev_avail

match_flag_type std::regex_constants::match_prev_avail
| inlineconstexpr

--first is a valid iterator position. When this flag is set then the flags match_not_bol and match_not_bow are ignored by the algorithms regex_match, regex_search, and regex_replace, and by the iterators regex_iterator and regex_token_iterator.

Definition at line 323 of file regex_constants.h.

Referenced by std::regex_iterator< _Bi_iter, _Ch_type, _Rx_traits >::operator++().

## ◆ multiline

syntax_option_type std::regex_constants::multiline
| inlineconstexpr

Specifies that the ^ anchor matches at the beginning of a line, and the $ anchor matches at the end of a line, not only at the beginning/end of the input. Valid for the ECMAScript syntax, ignored otherwise.

Since
  C++17

Definition at line 175 of file regex_constants.h.

## ◆ nosubs

syntax_option_type std::regex_constants::nosubs
| inlineconstexpr

Specifies that when a regular expression is matched against a character container sequence, no sub-expression matches are to be stored in the supplied match_results structure.

Definition at line 96 of file regex_constants.h.

## ◆ optimize

syntax_option_type std::regex_constants::optimize
| inlineconstexpr

Specifies that the regular expression engine should pay more attention to the speed with which regular expressions are matched, and less to the speed with which regular expression objects are constructed. Otherwise it has no detectable effect on the program output.

Definition at line 104 of file regex_constants.h.